gap> START_TEST("HAPprime version 0.3 userguide examples");
gap> HAPprimeInfoLevel := InfoLevel(InfoHAPprime);;
gap> SetInfoLevel(InfoHAPprime, 0);;
gap> #
# from paragraph [ 2, 1, 0, 24 ][ "/home/graham/pkg/happrime-0.3/doc/userguide/examples.xml", 129 ]

gap> G := SmallGroup(64, 134);;
gap> # First construct a FG-resolution for the group G
gap> R := ResolutionPrimePowerGroupRadical(G, 10);
Resolution of length 10 in characteristic 2 for <pc group of size 64 with
6 generators> .
No contracting homotopy available.
A partial contracting homotopy is available.

gap> # Convert this into a cochain complex (over the prime field with p=2)
gap> C := HomToIntegersModP(R, 2);
Cochain complex of length 10 in characteristic 2 .

gap> # And get the rank of the 9th cohomology group
gap> b9 := Cohomology(C, 9);
55
gap> 
gap> # Since R is a free resolution, the ranks of the cohomology groups
gap> # are the same as the module ranks in R
gap> ResolutionModuleRanks(R);
[ 3, 6, 10, 15, 21, 28, 36, 45, 55, 66 ]
# from paragraph [ 2, 2, 1, 10 ][ "/home/graham/pkg/happrime-0.3/doc/userguide/examples.xml", 229 ]

gap> G := SmallGroup(16, 3);;
gap> A := ModPCohomologyRing(G, 5);
<algebra of dimension 34 over GF(2)>
gap> Mod2CohomologyRingPresentation(A);
Graded algebra GF(2)[ x_1, x_2, x_3, x_4, x_5 ] /
[ x_1*x_2, x_1^2, x_1*x_5, x_2^2*x_3+x_5^2 ] with indeterminate degrees
[ 1, 1, 2, 2, 2 ]
# from paragraph [ 2, 2, 2, 5 ][ "/home/graham/pkg/happrime-0.3/doc/userguide/examples.xml", 311 ]

gap> SetInfoLevel(InfoHAPprime, 1);
gap> G := SmallGroup(16, 3);;
gap> A := Mod2CohomologyRingPresentation(G);
#I  E_2 = GF(2)[ x_1, x_2 ] x GF(2)[ x_3, x_4 ]
#I    with generator degrees [ 1, 1 ] and [ 1, 1 ] respectively
#I    d_2(x_1) = zero
#I    d_2(x_2) = zero
#I    d_2(x_3) = x_1*x_2
#I    d_2(x_4) = x_1^2
#I  E_3 = GF(2)[ x_5, x_6, x_7, x_8, x_9 ]/[ x_6*x_9, x_6^2, x_5*x_6, x_5^2*x_\
7+x_9^2 ]
#I  E_3 = GF(2)[ x_2, x_1, x_4^2, x_3^2, x_1*x_3+x_2*x_4 ]/[ x_1^2*x_3+x_1*x_2\
*x_4, x_1^2, x_1*x_2, x_1^2*x_3^2 ]
#I    d_3(x_2) = zero
#I    d_3(x_1) = zero
#I    d_3(x_4^2) = zero
#I    d_3(x_3^2) = x_1^2*x_2+x_1*x_2^2 = 0*Z(2)
#I    d_3(x_1*x_3+x_2*x_4) = zero
#I  E_4 = GF(2)[ x_10, x_11, x_12, x_13, x_14 ]/[ x_11*x_14, x_11^2, x_10*x_11\
, x_10^2*x_12+x_14^2 ]
#I  E_4 = GF(2)[ x_2, x_1, x_4^2, x_3^2, x_1*x_3+x_2*x_4 ]/[ x_1^2*x_3+x_1*x_2\
*x_4, x_1^2, x_1*x_2, x_1^2*x_3^2 ]
#I    d_4(x_2) = zero
#I    d_4(x_1) = zero
#I    d_4(x_4^2) = zero
#I    d_4(x_3^2) = zero
#I    d_4(x_1*x_3+x_2*x_4) = zero
#I  E_inf = GF(2)[ x_10, x_11, x_12, x_13, x_14 ]/[ x_11*x_14, x_11^2, x_10*x_\
11, x_10^2*x_12+x_14^2 ]
#I  E_inf = GF(2)[ x_2, x_1, x_4^2, x_3^2, x_1*x_3+x_2*x_4 ]/[ x_1^2*x_3+x_1*x\
_2*x_4, x_1^2, x_1*x_2, x_1^2*x_3^2 ]
#I  Renaming indeterminates and sorting into increasing degree
Graded algebra GF(2)[ x_1, x_2, x_3, x_4, x_5 ] /
[ x_1*x_2, x_1^2, x_1*x_5, x_2^2*x_3+x_5^2 ] with indeterminate degrees
[ 1, 1, 2, 2, 2 ]
gap> # Now extract data about the presentation
gap> BaseRing(A);
GF(2)[x_1,x_2,x_3,x_4,x_5]
gap> GeneratorsOfPresentationIdeal(A);
[ x_1*x_2, x_1^2, x_1*x_5, x_2^2*x_3+x_5^2 ]
gap> IndeterminateDegrees(A);
[ 1, 1, 2, 2, 2 ]
gap> MaximumDegreeForPresentation(A);
4

gap> #
gap> SetInfoLevel(InfoHAPprime, HAPprimeInfoLevel);
gap> STOP_TEST("HAPprime/tst/userguideexamples.tst", 4550000000);
