################################################################################
##
##  simpcomp / generate.gd
##
##  Generate simplicial complexes or construct them using existing
##  complexes.
##
##  $Id: generate.gd 8 2009-11-26 13:05:35Z jonathan $
##
################################################################################

## GAPDoc include
## <#GAPDoc Label="generate">
## <Section>
## <Heading>Creating an <C>SCSimplicialComplex</C> object from a facet list</Heading>
##
##  This section contains functions to generate or to construct new simplicial  complexes. Some of them obtain new complexes from existing ones, some generate  new complexes.
##
## <#Include Label="SCFromFacets"/>
## <#Include Label="SC"/>
## <#Include Label="SCFromDifferenceCycles"/>
## <#Include Label="SCFromGenerators"/>
##
## </Section>
##
## <Section>
## <Heading>Generating some standard triangulations</Heading>
##
## <#Include Label="SCBdCrossPolytope"/>
## <#Include Label="SCBdSimplex"/>
## <#Include Label="SCEmpty"/>
## <#Include Label="SCSimplex"/>
## </Section>
##
## <Section>
## <Heading>Generating new complexes from old</Heading>
##
## <#Include Label="SCCartesianPower"/>
## <#Include Label="SCCartesianProduct"/>
## <#Include Label="SCConnectedComponents"/>
## <#Include Label="SCConnectedProduct"/>
## <#Include Label="SCConnectedSum"/>
## <#Include Label="SCConnectedSumMinus"/>
## <#Include Label="SCDifferenceCycleCompress"/>
## <#Include Label="SCDifferenceCycleExpand"/>
## <#Include Label="SCFVectorBdCrossPolytope"/>
## <#Include Label="SCFVectorBdSimplex"/>
## <#Include Label="SCStronglyConnectedComponents"/>
## 
## </Section>
##
## <#/GAPDoc>

DeclareGlobalFunction("SCFromDifferenceCycles");
DeclareGlobalFunction("SCFromGenerators");
DeclareGlobalFunction("SCBdCrossPolytope");
DeclareGlobalFunction("SCBdSimplex");
DeclareGlobalFunction("SCCartesianPower");
DeclareGlobalFunction("SCCartesianProduct");
DeclareGlobalFunction("SCConnectedComponents");
DeclareGlobalFunction("SCConnectedProduct");
DeclareGlobalFunction("SCConnectedSum");
DeclareGlobalFunction("SCConnectedSumMinus");
DeclareGlobalFunction("SCDifferenceCycleCompress");
DeclareGlobalFunction("SCDifferenceCycleExpand");
DeclareGlobalFunction("SCEmpty");
DeclareGlobalFunction("SCFVectorBdCrossPolytope");
DeclareGlobalFunction("SCFVectorBdSimplex");
DeclareGlobalFunction("SCSimplex");
DeclareGlobalFunction("SCStronglyConnectedComponents");