################################################################################
##
##  simpcomp / labelops.gd
##
##  Functions operating on the labels of a complex such a the name or the
##  vertex labeling.
##
##  $Id: labelops.gd 2 2009-11-17 13:04:18Z felix $
##
################################################################################

## GAPDoc include
## <#GAPDoc Label="labelops">
## <Section> 
## <Heading>Vertex labelings and label operations</Heading>
##
## Functions operating on the labels of a complex such as the name or the
## vertex labeling.<P/>
## Internally, <Package>simpcomp</Package> uses the standard labeling <M>[1, \ldots , n]</M>. It is recommended to use simple vertex labels like integers end, whenever possible, the standard labeling, see also <Ref Func="SCRelabelStandard" />.
## 
## <#Include Label="SCLabelMax"/>
## <#Include Label="SCLabelMin"/>
## <#Include Label="SCLabels"/>
## <#Include Label="SCRelabel"/>
## <#Include Label="SCRelabelStandard"/>
## <#Include Label="SCRelabelTransposition"/>
## <#Include Label="SCRename"/>
## <#Include Label="SCSortComplex"/>
## <#Include Label="SCUnlabelFace"/>
##
## </Section>
## <#/GAPDoc>

DeclareGlobalFunction("SCLabelMax");
DeclareGlobalFunction("SCLabelMin");
DeclareGlobalFunction("SCLabels");
DeclareGlobalFunction("SCRelabel");
DeclareGlobalFunction("SCRelabelStandard");
DeclareGlobalFunction("SCRelabelTransposition");
DeclareGlobalFunction("SCRename");
DeclareGlobalFunction("SCSortComplex");
DeclareGlobalFunction("SCUnlabelFace");

