################################################################################
##
##  simpcomp / operations.gd
##
##  Operations on simplicial complexes.
##
##  $Id: operations.gd 8 2009-11-26 13:05:35Z jonathan $
##
################################################################################

## <#GAPDoc Label="operations">
## <Section> 
## <Heading>Operations on simplicial complexes</Heading>
##
##  The following functions perform operations on simplicial complexes.
##  Most of them return simplicial complexes. Thus, this section is
##  closely related to section ''Generate new complexes from old'' earlier in
##  this chapter. However, the data generated here is rather seen as an
##  intrinsic attribute of the original complex and not as an independent
##  complex.
##
## <#Include Label="SCAlexanderDual"/>
## <#Include Label="SCCollapseGreedy"/>
## <#Include Label="SCCone"/>
## <#Include Label="SCDeletedJoin"/>
## <#Include Label="SCDifference"/>
## <#Include Label="SCHandleAddition"/>
## <#Include Label="SCIntersection"/>
## <#Include Label="SCIsIsomorphic"/>
## <#Include Label="SCIsSubcomplex"/>
## <#Include Label="SCIsomorphism"/>
## <#Include Label="SCIsomorphismEx"/>
## <#Include Label="SCJoin"/>
## <#Include Label="SCLink"/>
## <#Include Label="SCLinks"/>
## <#Include Label="SCNeighbors"/>
## <#Include Label="SCNeighborsEx"/>
## <#Include Label="SCShelling"/>
## <#Include Label="SCShellingExt"/>
## <#Include Label="SCShellings"/>
## <#Include Label="SCSpan"/>
## <#Include Label="SCStar"/>
## <#Include Label="SCStars"/>
## <#Include Label="SCSuspension"/>
## <#Include Label="SCUnion"/>
## <#Include Label="SCVertexIdentification"/>
## <#Include Label="SCWedge"/>
##
## </Section>
## <#/GAPDoc>

#DeclareGlobalFunction("SCAlexanderDual");
DeclareGlobalFunction("SCCollapseGreedy");
#DeclareGlobalFunction("SCCone");
#DeclareGlobalFunction("SCDeletedJoin");
DeclareGlobalFunction("SCHandleAddition");
DeclareGlobalFunction("SCIsIsomorphic");
DeclareGlobalFunction("SCIsSubcomplex");
DeclareGlobalFunction("SCIsomorphism");
DeclareGlobalFunction("SCIsomorphismEx");
#DeclareGlobalFunction("SCJoin");
#DeclareGlobalFunction("SCLink");
DeclareGlobalFunction("SCLinks");
DeclareGlobalFunction("SCNeighbors");
DeclareGlobalFunction("SCNeighborsEx");
DeclareGlobalFunction("SCShelling");
DeclareGlobalFunction("SCShellingExt");
DeclareGlobalFunction("SCShellings");
DeclareGlobalFunction("SCSpan");
#DeclareGlobalFunction("SCStar");
DeclareGlobalFunction("SCStars");
#DeclareGlobalFunction("SCSuspension");
DeclareGlobalFunction("SCVertexIdentification");
#DeclareGlobalFunction("SCWedge");

################################################################################