################################################################################
##
##  simpcomp / pkghom.gi
##
##  Loaded when `homology' package is available
##
##  $Id: pkghom.gi 2 2009-11-17 13:04:18Z felix $
##
################################################################################


#setup homology package settings
SetHomologyAlgorithm(EliminateGMPAlgorithm);
SetHomologyGroupFormat(GapFormat);
HomologyInfo(0);


InstallGlobalFunction(SCHomology,
	function(complex)

	local hom,facets;
	
	if(not SCIsSimplicialComplex(complex)) then
		SCError()("SCHomology: first argument must be of type SCSimplicialComplex.\n");
		return fail;
	fi;

	if not IsBoundGlobal("SimplicialHomology") then
		return SCHomologyInternal(complex);
	fi;
	
	hom:=SCPropertyByName(complex,"Homology");
	if hom<>fail and not SCIntFunc.ForceRecalcEnabled(complex) then
		return hom;
	fi;
		
	facets:=SCFacetsEx(complex);
	if facets=fail then
		return fail;
	fi;
	
	SetHomologyAlgorithm(EliminateGMPAlgorithm);
	SetHomologyGroupFormat(GapFormat);
	HomologyInfo(0);
	hom:=SimplicialHomology(facets);
	
	if(hom=fail) then
		SCError()("SCHomology: computing homology failed.\n");
		return fail;
	fi;
	
	SCPropertySet(complex,"Homology",hom);

	if IsBound(hom[1]) and hom[1]=[0,[]] then
		SCPropertySet(complex,"IsConnected",true);
	else
		SCPropertySet(complex,"IsConnected",false);
	fi;
	return hom;
end);

