################################################################################
##
##  simpcomp / prophandler.gd
##
##  contains property handlers
##
##  $Id$
##
################################################################################


################################################################################
## <#GAPDoc Label="prophandlers">
##	This section contains a table of all property handlers of a <C>SCSimplicialComplex</C> object.
##
## <Table Align="ll">
## <Row><Item><B>Property handler</B></Item><Item><B>Function called</B></Item></Row>
## <HorLine/>
## <Row><Item></Item><Item></Item></Row>
## <Row><Item>ASDet</Item><Item><Ref Func="SCAltshulerSteinberg"/></Item></Row>
## <Row><Item>AlexanderDual</Item><Item><Ref Func="SCAlexanderDual"/></Item></Row>
## <Row><Item>AutomorphismGroup</Item><Item><Ref Func="SCAutomorphismGroup"/></Item></Row>
## <Row><Item>AutomorphismGroupInternal</Item><Item><Ref Func="SCAutomorphismGroupInternal"/></Item></Row>
## <Row><Item>Boundary</Item><Item><Ref Func="SCBoundary"/></Item></Row>
## <Row><Item>BoundaryOperatorMatrix</Item><Item><Ref Func="SCBoundaryOperatorMatrix"/></Item></Row>
## <Row><Item>Chi</Item><Item><Ref Func="SCEulerCharacteristic"/></Item></Row>
## <Row><Item>CoboundaryOperatorMatrix</Item><Item><Ref Func="SCCoboundaryOperatorMatrix"/></Item></Row>
## <Row><Item>Cohomology</Item><Item><Ref Func="SCCohomology"/></Item></Row>
## <Row><Item>CohomologyBasis</Item><Item><Ref Func="SCCohomologyBasis"/></Item></Row>
## <Row><Item>CohomologyBasisAsSimplices</Item><Item><Ref Func="SCCohomologyBasisAsSimplices"/></Item></Row>
## <Row><Item>CollapseGreedy</Item><Item><Ref Func="SCCollapseGreedy"/></Item></Row>
## <Row><Item>Cone</Item><Item><Ref Func="SCCone"/></Item></Row>
## <Row><Item>ConnectedComponents</Item><Item><Ref Func="SCConnectedComponents"/></Item></Row>
## <Row><Item>Copy</Item><Item><Ref Func="SCCopy"/></Item></Row>
## <Row><Item>CupProduct</Item><Item><Ref Func="SCCupProduct"/></Item></Row>
## <Row><Item>DeletedJoin</Item><Item><Ref Func="SCDeletedJoin"/></Item></Row>
## <Row><Item>DetermineTopologicalType</Item><Item><Ref Func="SCLibDetermineTopologicalType"/></Item></Row>
## <Row><Item>Difference</Item><Item><Ref Func="SCDifference"/></Item></Row>
## <Row><Item>Dim</Item><Item><Ref Func="SCDim"/></Item></Row>
## <Row><Item>DualGraph</Item><Item><Ref Func="SCDualGraph"/></Item></Row>
## <Row><Item>Equivalent</Item><Item><Ref Func="SCEquivalent"/></Item></Row>
## <Row><Item>ExportJavaView</Item><Item><Ref Func="SCExportJavaView"/></Item></Row>
## <Row><Item>ExportLatexTable</Item><Item><Ref Func="SCExportLatexTable"/></Item></Row>
## <Row><Item>ExportPolymake</Item><Item><Ref Func="SCExportPolymake"/></Item></Row>
## </Table>
## <Table Align="ll">
## <Row><Item>F</Item><Item><Ref Func="SCFVector"/></Item></Row>
## <Row><Item>FaceLattice</Item><Item><Ref Func="SCFaceLattice"/></Item></Row>
## <Row><Item>FaceLatticeEx</Item><Item><Ref Func="SCFaceLatticeEx"/></Item></Row>
## <Row><Item>Faces</Item><Item><Ref Func="SCFaces"/></Item></Row>
## <Row><Item>FacesEx</Item><Item><Ref Func="SCFacesEx"/></Item></Row>
## <Row><Item>Facets</Item><Item><Ref Func="SCFacets"/></Item></Row>
## <Row><Item>FacetsEx</Item><Item><Ref Func="SCFacetsEx"/></Item></Row>
## <Row><Item>FpBetti</Item><Item><Ref Func="SCFpBettiNumbers"/></Item></Row>
## <Row><Item>FundamentalGroup</Item><Item><Ref Func="SCFundamentalGroup"/></Item></Row>
## <Row><Item>G</Item><Item><Ref Func="SCGVector"/></Item></Row>
## <Row><Item>Generators</Item><Item><Ref Func="SCGenerators"/></Item></Row>
## <Row><Item>GeneratorsEx</Item><Item><Ref Func="SCGeneratorsEx"/></Item></Row>
## <Row><Item>H</Item><Item><Ref Func="SCHVector"/></Item></Row>
## <Row><Item>HandleAddition</Item><Item><Ref Func="SCHandleAddition"/></Item></Row>
## <Row><Item>HasBoundary</Item><Item><Ref Func="SCHasBoundary"/></Item></Row>
## <Row><Item>HasInterior</Item><Item><Ref Func="SCHasInterior"/></Item></Row>
## <Row><Item>Homology</Item><Item><Ref Func="SCHomology"/></Item></Row>
## <Row><Item>HomologyBasis</Item><Item><Ref Func="SCHomologyBasis"/></Item></Row>
## <Row><Item>HomologyBasisAsSimplices</Item><Item><Ref Func="SCHomologyBasisAsSimplices"/></Item></Row>
## <Row><Item>HomologyInternal</Item><Item><Ref Func="SCHomologyInternal"/></Item></Row>
## <Row><Item>Incidences</Item><Item><Ref Func="SCIncidences"/></Item></Row>
## <Row><Item>IncidencesEx</Item><Item><Ref Func="SCIncidencesEx"/></Item></Row>
## <Row><Item>Interior</Item><Item><Ref Func="SCInterior"/></Item></Row>
## <Row><Item>Intersection</Item><Item><Ref Func="SCIntersection"/></Item></Row>
## <Row><Item>IntersectionForm</Item><Item><Ref Func="SCIntersectionForm"/></Item></Row>
## <Row><Item>IntersectionFormDimensionality</Item><Item><Ref Func="SCIntersectionFormDimensionality"/></Item></Row>
## <Row><Item>IntersectionFormParity</Item><Item><Ref Func="SCIntersectionFormParity"/></Item></Row>
## <Row><Item>IsCentrallySymmetric</Item><Item><Ref Func="SCIsCentrallySymmetric"/></Item></Row>
## <Row><Item>IsConnected</Item><Item><Ref Func="SCIsConnected"/></Item></Row>
## <Row><Item>IsEmpty</Item><Item><Ref Func="SCIsEmpty"/></Item></Row>
## <Row><Item>IsEulerianManifold</Item><Item><Ref Func="SCIsEulerianManifold"/></Item></Row>
## <Row><Item>IsHomologySphere</Item><Item><Ref Func="SCIsHomologySphere"/></Item></Row>
## <Row><Item>IsInKd</Item><Item><Ref Func="SCIsInKd"/></Item></Row>
## <Row><Item>IsIsomorphic</Item><Item><Ref Func="SCIsIsomorphic"/></Item></Row>
## <Row><Item>IsKNeighborly</Item><Item><Ref Func="SCIsKNeighborly"/></Item></Row>
## <Row><Item>IsKStackedSphere</Item><Item><Ref Func="SCIsKStackedSphere"/></Item></Row>
## <Row><Item>IsManifold</Item><Item><Ref Func="SCIsManifold"/></Item></Row>
## <Row><Item>IsMovable</Item><Item><Ref Func="SCIsMovableComplex"/></Item></Row>
## <Row><Item>IsOrientable</Item><Item><Ref Func="SCIsOrientable"/></Item></Row>
## <Row><Item>IsPM</Item><Item><Ref Func="SCIsPseudoManifold"/></Item></Row>
## <Row><Item>IsPure</Item><Item><Ref Func="SCIsPure"/></Item></Row>
## <Row><Item>IsShellable</Item><Item><Ref Func="SCIsShellable"/></Item></Row>
## <Row><Item>IsStronglyConnected</Item><Item><Ref Func="SCIsStronglyConnected"/></Item></Row>
## <Row><Item>IsSubcomplex</Item><Item><Ref Func="SCIsSubcomplex"/></Item></Row>
## <Row><Item>Isomorphism</Item><Item><Ref Func="SCIsomorphism"/></Item></Row>
## <Row><Item>IsomorphismEx</Item><Item><Ref Func="SCIsomorphismEx"/></Item></Row>
## </Table>
## <Table Align="ll">
## <Row><Item>Join</Item><Item><Ref Func="SCJoin"/></Item></Row>
## <Row><Item>LabelMax</Item><Item><Ref Func="SCLabelMax"/></Item></Row>
## <Row><Item>LabelMin</Item><Item><Ref Func="SCLabelMin"/></Item></Row>
## <Row><Item>Labels</Item><Item><Ref Func="SCLabels"/></Item></Row>
## <Row><Item>Link</Item><Item><Ref Func="SCLink"/></Item></Row>
## <Row><Item>Links</Item><Item><Ref Func="SCLinks"/></Item></Row>
## <Row><Item>Load</Item><Item><Ref Func="SCLoad"/></Item></Row>
## <Row><Item>MinimalNonFaces</Item><Item><Ref Func="SCMinimalNonFaces"/></Item></Row>
## <Row><Item>MinimalNonFacesEx</Item><Item><Ref Func="SCMinimalNonFacesEx"/></Item></Row>
## <Row><Item>Move</Item><Item><Ref Func="SCMove"/></Item></Row>
## <Row><Item>Moves</Item><Item><Ref Func="SCMoves"/></Item></Row>
## <Row><Item>Name</Item><Item><Ref Func="SCName"/></Item></Row>
## <Row><Item>Neighborliness</Item><Item><Ref Func="SCNeighborliness"/></Item></Row>
## <Row><Item>Neighbors</Item><Item><Ref Func="SCNeighbors"/></Item></Row>
## <Row><Item>NeighborsEx</Item><Item><Ref Func="SCNeighborsEx"/></Item></Row>
## <Row><Item>Orientation</Item><Item><Ref Func="SCOrientation"/></Item></Row>
## <Row><Item>RMoves</Item><Item><Ref Func="SCRMoves"/></Item></Row>
## <Row><Item>Recalc</Item><Item><Ref Func="SCForceRecalc"/></Item></Row>
## <Row><Item>Reduce</Item><Item><Ref Func="SCReduceComplex"/></Item></Row>
## <Row><Item>ReduceAsSubcomplex</Item><Item><Ref Func="SCReduceAsSubcomplex"/></Item></Row>
## <Row><Item>ReduceEx</Item><Item><Ref Func="SCReduceComplexEx"/></Item></Row>
## <Row><Item>Relabel</Item><Item><Ref Func="SCRelabel"/></Item></Row>
## <Row><Item>RelabelStandard</Item><Item><Ref Func="SCRelabelStandard"/></Item></Row>
## <Row><Item>RelabelTransposition</Item><Item><Ref Func="SCRelabelTransposition"/></Item></Row>
## <Row><Item>Rename</Item><Item><Ref Func="SCRename"/></Item></Row>
## <Row><Item>Save</Item><Item><Ref Func="SCSave"/></Item></Row>
## <Row><Item>Shelling</Item><Item><Ref Func="SCShelling"/></Item></Row>
## <Row><Item>ShellingExt</Item><Item><Ref Func="SCShellingExt"/></Item></Row>
## <Row><Item>Shellings</Item><Item><Ref Func="SCShellings"/></Item></Row>
## <Row><Item>Skel</Item><Item><Ref Func="SCSkel"/></Item></Row>
## <Row><Item>SkelEx</Item><Item><Ref Func="SCSkelEx"/></Item></Row>
## <Row><Item>Slicing</Item><Item><Ref Func="SCNSSlicing"/></Item></Row>
## <Row><Item>SortComplex</Item><Item><Ref Func="SCSortComplex"/></Item></Row>
## <Row><Item>Span</Item><Item><Ref Func="SCSpan"/></Item></Row>
## <Row><Item>SpanningTree</Item><Item><Ref Func="SCSpanningTree"/></Item></Row>
## <Row><Item>Star</Item><Item><Ref Func="SCStar"/></Item></Row>
## <Row><Item>Stars</Item><Item><Ref Func="SCStars"/></Item></Row>
## <Row><Item>StronglyConnectedComponents</Item><Item><Ref Func="SCStronglyConnectedComponents"/></Item></Row>
## <Row><Item>Suspension</Item><Item><Ref Func="SCSuspension"/></Item></Row>
## <Row><Item>Union</Item><Item><Ref Func="SCUnion"/></Item></Row>
## <Row><Item>UnlabelFace</Item><Item><Ref Func="SCUnlabelFace"/></Item></Row>
## <Row><Item>VertexIdentification</Item><Item><Ref Func="SCVertexIdentification"/></Item></Row>
## <Row><Item>Vertices</Item><Item><Ref Func="SCVertices"/></Item></Row>
## <Row><Item>VerticesEx</Item><Item><Ref Func="SCVerticesEx"/></Item></Row>
## <Row><Item>Wedge</Item><Item><Ref Func="SCWedge"/></Item></Row>
## </Table>
##		
##<#/GAPDoc>
################################################################################

#property handlers for SCSimplicialComplex
SCIntFunc.SCPropertyHandlers:=rec(
#bistellar.gd
Equivalent:=SCEquivalent,
IsKStackedSphere:=SCIsKStackedSphere,
IsManifold:=SCIsManifold,
IsMovable:=SCIsMovableComplex,
Move:=SCMove,
Moves:=SCMoves,
RMoves:=SCRMoves,
ReduceAsSubcomplex:=SCReduceAsSubcomplex,
Reduce:=SCReduceComplex,
ReduceEx:=SCReduceComplexEx,

#complex.gd
Copy:=SCCopy,
Recalc:=SCForceRecalc,

#glprops.gd
ASDet:=SCAltshulerSteinberg,
AutomorphismGroup:=SCAutomorphismGroup,
AutomorphismGroupInternal:=SCAutomorphismGroupInternal,
Boundary:=SCBoundary,
ConnectedComponents:=SCConnectedComponents,
Dim:=SCDim,
DualGraph:=SCDualGraph,
Chi:=SCEulerCharacteristic,
F:=SCFVector,
FaceLattice:=SCFaceLattice,
FaceLatticeEx:=SCFaceLatticeEx,
Faces:=SCFaces,
FacesEx:=SCFacesEx,
Facets:=SCFacets,
FacetsEx:=SCFacetsEx,
FpBetti:=SCFpBettiNumbers,
FundamentalGroup:=SCFundamentalGroup,
G:=SCGVector,
Generators:=SCGenerators,
GeneratorsEx:=SCGeneratorsEx,
H:=SCHVector,
HasBoundary:=SCHasBoundary,
HasInterior:=SCHasInterior,
Homology:=SCHomology,
Incidences:=SCIncidences,
IncidencesEx:=SCIncidencesEx,
Interior:=SCInterior,
IsCentrallySymmetric:=SCIsCentrallySymmetric,
IsConnected:=SCIsConnected,
IsEmpty:=SCIsEmpty,
IsEulerianManifold:=SCIsEulerianManifold,
IsHomologySphere:=SCIsHomologySphere,
IsInKd:=SCIsInKd,
IsKNeighborly:=SCIsKNeighborly,
IsOrientable:=SCIsOrientable,
IsPM:=SCIsPseudoManifold,
IsPure:=SCIsPure,
IsShellable:=SCIsShellable,
IsStronglyConnected:=SCIsStronglyConnected,
MinimalNonFaces:=SCMinimalNonFaces,
MinimalNonFacesEx:=SCMinimalNonFacesEx,
Name:=SCName,
Neighborliness:=SCNeighborliness,
Orientation:=SCOrientation,
Skel:=SCSkel,
SkelEx:=SCSkelEx,
SpanningTree:=SCSpanningTree,
StronglyConnectedComponents:=SCStronglyConnectedComponents,
Vertices:=SCVertices,
VerticesEx:=SCVerticesEx,

#homology.gd
BoundaryOperatorMatrix:=SCBoundaryOperatorMatrix,
HomologyBasis:=SCHomologyBasis,
HomologyBasisAsSimplices:=SCHomologyBasisAsSimplices,
HomologyInternal:=SCHomologyInternal,
CoboundaryOperatorMatrix:=SCCoboundaryOperatorMatrix,
Cohomology:=SCCohomology,
CohomologyBasis:=SCCohomologyBasis,
CohomologyBasisAsSimplices:=SCCohomologyBasisAsSimplices,
CupProduct:=SCCupProduct,
IntersectionForm:=SCIntersectionForm,
IntersectionFormParity:=SCIntersectionFormParity,
IntersectionFormDimensionality:=SCIntersectionFormDimensionality,

#io.gd
Load:=SCLoad,
Save:=SCSave,
ExportPolymake:=SCExportPolymake,
ExportLatexTable:=SCExportLatexTable,
ExportJavaView:=SCExportJavaView,

#labelops.gp
LabelMax:=SCLabelMax,
LabelMin:=SCLabelMin,
Labels:=SCLabels,
Relabel:=SCRelabel,
RelabelStandard:=SCRelabelStandard,
RelabelTransposition:=SCRelabelTransposition,
Rename:=SCRename,
SortComplex:=SCSortComplex,
UnlabelFace:=SCUnlabelFace,

#operations.gd
AlexanderDual:=SCAlexanderDual,
CollapseGreedy:=SCCollapseGreedy,
Cone:=SCCone,
DeletedJoin:=SCDeletedJoin,
Difference:=SCDifference,
HandleAddition:=SCHandleAddition,
Intersection:=SCIntersection,
IsIsomorphic:=SCIsIsomorphic,
IsSubcomplex:=SCIsSubcomplex,
Isomorphism:=SCIsomorphism,
IsomorphismEx:=SCIsomorphismEx,
Join:=SCJoin,
Link:=SCLink,
Links:=SCLinks,
Neighbors:=SCNeighbors,
NeighborsEx:=SCNeighborsEx,
Shelling:=SCShelling,
ShellingExt:=SCShellingExt,
Shellings:=SCShellings,
Span:=SCSpan,
Star:=SCStar,
Stars:=SCStars,
Suspension:=SCSuspension,
Union:=SCUnion,
VertexIdentification:=SCVertexIdentification,
Wedge:=SCWedge,

#lib.gd
DetermineTopologicalType:=SCLibDetermineTopologicalType,

#normalsurface.gd
Slicing:=SCNSSlicing

);


################################################################################
##<#GAPDoc Label="prophandlersns">
##
##	This section contains a table of all property handlers of a <C>SCNormalSurface</C> object.
##
## <Table Align="ll">
## <Row><Item><B>Property handler</B></Item><Item><B>Function called</B></Item></Row>
## <HorLine/>
## <Row><Item></Item><Item></Item></Row>
## <Row><Item>Betti</Item><Item>SCNSFpBettiNumbers</Item></Row>
## <Row><Item>Chi</Item><Item>SCNSEulerCharacteristic</Item></Row>
## <Row><Item>ConnComp</Item><Item>SCConnectedComponents</Item></Row>
## <Row><Item>Connected</Item><Item>SCIsConnected</Item></Row>
## <Row><Item>Copy</Item><Item>SCNSCopy</Item></Row>
## <Row><Item>Dim</Item><Item>SCNSDim</Item></Row>
## <Row><Item>F</Item><Item>SCNSFVector</Item></Row>
## <Row><Item>FaceLattice</Item><Item>SCNSFaceLattice</Item></Row>
## <Row><Item>Faces</Item><Item>SCNSSkel</Item></Row>
## <Row><Item>Facets</Item><Item>SCFacets</Item></Row>
## <Row><Item>Genus</Item><Item>SCNSGenus</Item></Row>
## <Row><Item>Homology</Item><Item>SCNSHomology</Item></Row>
## <Row><Item>IsEmpty</Item><Item>SCIsEmpty</Item></Row>
## <Row><Item>Labels</Item><Item>SCLabels</Item></Row>
## <Row><Item>Name</Item><Item>SCName</Item></Row>
## <Row><Item>Triangulation</Item><Item>SCNSSubdivision</Item></Row>
## <Row><Item>Type</Item><Item>SCNSTopologicalType</Item></Row>
## <Row><Item>Vertices</Item><Item>SCVertices</Item></Row>
## </Table>
##		
##<#/GAPDoc>
################################################################################


#property handlers for SCNormalSurface
SCIntFunc.SCNSPropertyHandlers:=rec(
#normalsurface.gd
 Betti:=SCNSFpBettiNumbers,
 Chi:=SCNSEulerCharacteristic,
 ConnComp:=SCConnectedComponents,
 Connected:=SCIsConnected,
 Copy:=SCNSCopy,
 Dim:=SCNSDim,
 F:=SCNSFVector,
 FaceLattice:=SCNSFaceLattice,
 Faces:=SCNSSkel,
 Facets:=SCFacets,
 Genus:=SCNSGenus,
 Homology:=SCNSHomology,
 IsEmpty:=SCIsEmpty,
 Labels:=SCLabels,
 Name:=SCName,
 Triangulation:=SCNSSubdivision,
 Type:=SCNSTopologicalType,
 Vertices:=SCVertices,
);



#Property handlers for SCLibRepository
SCIntFunc.SCLibRepositoryPropertyHandlers:=
rec(
Update:=SCLibUpdate,
IsLoaded:=SCLibIsLoaded,
Size:=SCLibSize,
Status:=SCLibStatus,
Flush:=SCLibFlush,
Add:=SCLibAdd,
Delete:=SCLibDelete,
Load:=SCLibLoad,
All:=SCLibAllComplexes,
SearchByName:=SCLibSearchByName,
SearchByAttribute:=SCLibSearchByAttribute,
DetermineTopologicalType:=SCLibDetermineTopologicalType
);

