################################################################################
##
##  simpcomp / tools.gd
##
##  Miscellaneous functions   
##
##  $Id: tools.gd 2 2009-11-17 13:04:18Z felix $
##
################################################################################


## <#GAPDoc Label="tools">
##
## The bahaviour of <Package>simpcomp</Package> can be changed by setting global options, functions for which will be described in the following.  
##
## <Section>
## <Heading><Package>simpcomp</Package> error handling</Heading>
##
## <Package>simpcomp</Package> can be configured to either enter a break loop when encountering an error or to just log the error and return <K>fail</K> in the called function. Examples for errors would be a computation failing or a <C>SCSimplicialComplex</C> object having an inconsistent internal state
##
## <#Include Label="SCErrorBreak"/>
## <#Include Label="SCErrorMail"/>
##
## </Section>
##
## <Section>
## <Heading>Email notification system</Heading>
##
## <Package>simpcomp</Package> comes with an email notification system that can be used for being notified of the progress of lengthy computations (such as reducing a complex via bistellar flips). See below for a descriptions of the mail notification related functions.
##
## <#Include Label="SCMailClearPending"/>
## <#Include Label="SCMailIsEnabled"/>
## <#Include Label="SCMailIsPending"/>
## <#Include Label="SCMailSend"/>
## <#Include Label="SCMailSendPending"/>
## <#Include Label="SCMailSetAddress"/>
## <#Include Label="SCMailSetEnabled"/>
## <#Include Label="SCMailSetMinInterval"/>
## </Section>
##
## <Section>
## <Heading>Testing the functionality of <Package>simpcomp</Package></Heading>
##
## <Package>simpcomp</Package> makes use of the &GAP; internal testing mechanisms and provides the user with a function to test the functionality of the package. 
##
## <#Include Label="SCRunTest"/>
## </Section>
##
##<#/GAPDoc>


DeclareGlobalFunction("SCError");
DeclareGlobalFunction("SCErrorBreak");
DeclareGlobalFunction("SCErrorMail");
DeclareGlobalFunction("SCMailClearPending");
DeclareGlobalFunction("SCMailIsEnabled");
DeclareGlobalFunction("SCMailIsPending");
DeclareGlobalFunction("SCMailSend");
DeclareGlobalFunction("SCMailSendPending");
DeclareGlobalFunction("SCMailSetAddress");
DeclareGlobalFunction("SCMailSetEnabled");
DeclareGlobalFunction("SCMailSetMinInterval");
DeclareGlobalFunction("SCRunTest");

