################################################################################
##
##  simpcomp / read.g
##
##  read.g for package simpcomp
##
##  $Id: read.g 15 2009-11-26 14:22:13Z felix $
##
################################################################################

InstallValue(SCSettings,
rec(
BreakOnError:=false,
MailOnError:=false
));
MakeReadWriteGlobal("SCSettings");

SCIntFunc.Version:="1.1.9";

InstallGlobalFunction(SCInfoLevel,
function(level)
  SetInfoLevel(InfoSimpcomp,level);
end);

ReadPackage("simpcomp","lib/propobject.gi");
ReadPackage("simpcomp","lib/complex.gi");
ReadPackage("simpcomp","lib/tools.gi");
ReadPackage("simpcomp","lib/io.gi");
ReadPackage("simpcomp","lib/lib.gi");

#overlay some functions of homology packge, if present
ReadPackage("simpcomp", "lib/pkghom.gd");

ReadPackage("simpcomp","lib/glprops.gi");
ReadPackage("simpcomp","lib/operations.gi");
ReadPackage("simpcomp","lib/labelops.gi");
ReadPackage("simpcomp","lib/generate.gi");
ReadPackage("simpcomp","lib/bistellar.gi");
ReadPackage("simpcomp", "lib/homology.gi");
ReadPackage("simpcomp", "lib/normalsurface.gi");

#load `homology' package specific functions if available
if(SCIntFunc.SetupHomology()=false) then
	ReadPackage("simpcomp", "lib/pkgnohom.gi");
else
	ReadPackage("simpcomp", "lib/pkghom.gi");
fi;

#load `GRAPE' package specific functions if available
if(SCIntFunc.SetupGrape()=false) then
	ReadPackage("simpcomp", "lib/pkgnogrape.gi");
else
	ReadPackage("simpcomp", "lib/pkggrape.gi");
fi;

SCSettings.ComplexCounter:=1;
SCIntFunc.CheckExternalProgramsAvailability();
ReadPackage("simpcomp", "lib/prophandler.gd");

MakeReadOnlyGlobal("SCIntFunc");

#load global library
InstallValue(SCLib,SCIntFunc.SCLibGlobalInit());

